## libcap2 2.44-1ubuntu0.22.04.2+11.0trisquel1

=== libcap/Makefile ===
#
# defines
#
topdir=$(shell pwd)/..
include ../Make.Rules
#
# Library version
#
LIBNAME=$(LIBTITLE).so
STACAPLIBNAME=$(LIBTITLE).a
#
STAPSXLIBNAME=libpsx.a
CFLAGS  := $(filter-out -fPIE,$(CFLAGS))
LDFLAGS := $(filter-out -fPIE,$(filter-out -pie,$(LDFLAGS)))

CAPFILES=cap_alloc cap_proc cap_extint cap_flag cap_text cap_file
PSXFILES=../psx/psx

INCLS=libcap.h cap_names.h $(INCS)
CAPOBJS=$(addsuffix .o, $(CAPFILES))
PSXOBJS=$(addsuffix .o, $(PSXFILES))

MAJLIBNAME=$(LIBNAME).$(VERSION)
MINLIBNAME=$(MAJLIBNAME).$(MINOR)
GPERF_OUTPUT = _caps_output.gperf

all: $(MINLIBNAME) $(STACAPLIBNAME) pcs $(STAPSXLIBNAME)

pcs: libcap.pc libpsx.pc

ifeq ($(BUILD_GPERF),yes)
USE_GPERF_OUTPUT = $(GPERF_OUTPUT)
INCLUDE_GPERF_OUTPUT = -DINCLUDE_GPERF_OUTPUT='"$(GPERF_OUTPUT)"'
endif

libcap.pc: libcap.pc.in
	sed -e 's,@prefix@,$(prefix),' \
		-e 's,@exec_prefix@,$(exec_prefix),' \
		-e 's,@libdir@,$(LIBDIR),' \
		-e 's,@includedir@,$(inc_prefix)/include,' \
		-e 's,@VERSION@,$(VERSION).$(MINOR),' \
		-e 's,@deps@,$(DEPS),' \
		$< >$@

libpsx.pc: libpsx.pc.in
	sed -e 's,@prefix@,$(prefix),' \
		-e 's,@exec_prefix@,$(exec_prefix),' \
		-e 's,@libdir@,$(LIBDIR),' \
		-e 's,@includedir@,$(inc_prefix)/include,' \
		-e 's,@VERSION@,$(VERSION).$(MINOR),' \
		-e 's,@deps@,$(DEPS),' \
		$< >$@

_makenames: _makenames.c cap_names.list.h
	$(BUILD_CC) $(BUILD_CFLAGS) $(BUILD_LDFLAGS) $(BUILD_CPPFLAGS) $< -o $@

cap_names.h: _makenames
	./_makenames > cap_names.h

$(GPERF_OUTPUT): cap_names.list.h
	perl -e 'print "struct __cap_token_s { const char *name; int index; };\n%{\n#include <stdlib.h>\nstatic const struct __cap_token_s *__cap_lookup_name(const char *, size_t);\n%}\n%%\n"; while ($$l = <>) { $$l =~ s/[\{\"]//g; $$l =~ s/\}.*// ; print $$l; }' < $< | gperf --ignore-case --language=ANSI-C --readonly --null-strings --global-table --hash-function-name=__cap_hash_name --lookup-function-name="__cap_lookup_name" -c -t -m20 $(INDENT) > $@
	sed -e 's/unsigned int len/size_t len/' -i $@

# Intention is that libcap keeps up with torvalds' tree, as reflected
# by this maintained version of the kernel header. libcap dynamically
# trims the meaning of "all" capabilities down to that of the running
# kernel as of 2.30.
UAPI_HEADER := $(topdir)/libcap/include/uapi/linux/capability.h
cap_names.list.h: Makefile $(UAPI_HEADER)
	@echo "=> making $@ from $(UAPI_HEADER)"
	perl -e 'while ($$l=<>) { if ($$l =~ /^\#define[ \t](CAP[_A-Z]+)[ \t]+([0-9]+)\s+$$/) { $$tok=$$1; $$val=$$2; $$tok =~ tr/A-Z/a-z/; print "{\"$$tok\",$$val},\n"; } }' $(UAPI_HEADER) | fgrep -v 0x > $@

$(STACAPLIBNAME): $(CAPOBJS)
	$(AR) rcs $@ $^
	$(RANLIB) $@

$(STAPSXLIBNAME): $(PSXOBJS)
	$(AR) rcs $@ $^
	$(RANLIB) $@

$(MINLIBNAME): $(CAPOBJS)
	$(LD) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -Wl,-soname,$(MAJLIBNAME) -o $@ $^
	ln -sf $(MINLIBNAME) $(MAJLIBNAME)
	ln -sf $(MAJLIBNAME) $(LIBNAME)

%.o: %.c $(INCLS)
	$(CC) $(CFLAGS) $(CPPFLAGS) $(IPATH) -c $< -o $@

cap_text.o: cap_text.c $(USE_GPERF_OUTPUT) $(INCLS)
	$(CC) $(CFLAGS) $(CPPFLAGS) $(IPATH) $(INCLUDE_GPERF_OUTPUT) -c $< -o $@

cap_test: cap_test.c libcap.h
	$(CC) $(CFLAGS) $(CPPFLAGS) $(IPATH) $< -o $@

test: cap_test
	./cap_test

install: install-static install-shared

install-static: install-static-cap install-static-psx

install-shared: install-shared-cap

install-cap: install-static-cap install-shared-cap

install-psx: install-static-psx

install-static-cap: install-common-cap $(STACAPLIBNAME)
	install -m 0644 $(STACAPLIBNAME) $(FAKEROOT)$(LIBDIR)/$(STACAPLIBNAME)

install-shared-cap: install-common-cap $(MINLIBNAME)
	install -m 0644 $(MINLIBNAME) $(FAKEROOT)$(LIBDIR)/$(MINLIBNAME)
	ln -sf $(MINLIBNAME) $(FAKEROOT)$(LIBDIR)/$(MAJLIBNAME)
	ln -sf $(MAJLIBNAME) $(FAKEROOT)$(LIBDIR)/$(LIBNAME)
ifeq ($(FAKEROOT),)
	-/sbin/ldconfig
endif

install-static-psx: install-common-psx $(STAPSXLIBNAME)
	install -m 0644 $(STAPSXLIBNAME) $(FAKEROOT)$(LIBDIR)/$(STAPSXLIBNAME)

install-common-cap: install-common libcap.pc
	install -m 0644 include/sys/capability.h $(FAKEROOT)$(INCDIR)/sys
	install -m 0644 libcap.pc $(FAKEROOT)$(PKGCONFIGDIR)/libcap.pc

install-common-psx: install-common libpsx.pc
	install -m 0644 include/sys/psx_syscall.h $(FAKEROOT)$(INCDIR)/sys
	install -m 0644 libpsx.pc $(FAKEROOT)$(PKGCONFIGDIR)/libpsx.pc

install-common:
	mkdir -p -m 0755 $(FAKEROOT)$(INCDIR)/sys
	mkdir -p -m 0755 $(FAKEROOT)$(PKGCONFIGDIR)
	mkdir -p -m 0755 $(FAKEROOT)$(LIBDIR)

clean:
	$(LOCALCLEAN)
	rm -f $(CAPOBJS) $(LIBNAME)* $(STACAPLIBNAME) libcap.pc libpsx.pc
	rm -f $(PSXOBJS) $(STAPSXLIBNAME)
	rm -f cap_names.h cap_names.list.h _makenames $(GPERF_OUTPUT) cap_test
	cd include/sys && $(LOCALCLEAN)

=== pam_cap/Makefile ===
# simple make file for the pam_cap module

topdir=$(shell pwd)/..
include ../Make.Rules

all: pam_cap.so
	$(MAKE) testlink

install: all
	mkdir -p -m 0755 $(FAKEROOT)$(LIBDIR)/security
	install -m 0755 pam_cap.so $(FAKEROOT)$(LIBDIR)/security

CFLAGS  := $(filter-out -fPIE,$(CFLAGS))
LDFLAGS := $(filter-out -fPIE,$(filter-out -pie,$(LDFLAGS)))

# Note (as the author of much of the Linux-PAM library, I am confident
# that this next line does *not* require -lpam on it.) If you think it
# does, *verify that it does*, and if you observe that it fails as
# written (and you know why it fails), email me and explain why. Thanks!

pam_cap.so: pam_cap.o
	$(LD) -o pam_cap.so $< $(LIBCAPLIB) $(LDFLAGS) -lpam

pam_cap.o: pam_cap.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(IPATH) -c $< -o $@

test_pam_cap: test_pam_cap.c pam_cap.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(IPATH) -o $@ test_pam_cap.c $(LIBCAPLIB) $(LDFLAGS) --static

testlink: test.c pam_cap.o
	$(CC) $(CFLAGS) -o $@ $+ -lpam -ldl $(LIBCAPLIB) $(LDFLAGS)

test: pam_cap.so
	make testlink

sudotest: test test_pam_cap
	$(DEB_GAIN_ROOT_CMD) ./test_pam_cap root 0x0 0x0 0x0 config=./capability.conf
	$(DEB_GAIN_ROOT_CMD) ./test_pam_cap root 0x0 0x0 0x0 config=./sudotest.conf
	$(DEB_GAIN_ROOT_CMD) ./test_pam_cap alpha 0x0 0x0 0x0 config=./capability.conf
	$(DEB_GAIN_ROOT_CMD) ./test_pam_cap alpha 0x0 0x1 0x80 config=./sudotest.conf
	$(DEB_GAIN_ROOT_CMD) ./test_pam_cap beta 0x0 0x1 0x0 config=./sudotest.conf
	$(DEB_GAIN_ROOT_CMD) ./test_pam_cap gamma 0x0 0x0 0x81 config=./sudotest.conf
	$(DEB_GAIN_ROOT_CMD) ./test_pam_cap delta 0x41 0x80 0x41 config=./sudotest.conf

clean:
	rm -f *.o *.so testlink test_pam_cap *~

=== progs/Makefile ===

topdir=$(shell pwd)/..
include $(topdir)/Make.Rules
#
# Programs: all of the examples that we will compile
#
PROGS=getpcaps capsh getcap setcap

BUILD=$(PROGS)

ifeq ($(DYNAMIC),yes)
LDPATH = LD_LIBRARY_PATH=../libcap
DEPSBUILD = all
else
LDFLAGS += --static
DEPSBUILD = libcap.a
endif

DEPS=../libcap/libcap.a

all: $(BUILD)

$(DEPS):
	make -C ../libcap $(DEPSBUILD)

$(BUILD): %: %.o $(DEPS)
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $< $(LIBCAPLIB) $(LDFLAGS)

%.o: %.c $(INCS)
	$(CC) $(IPATH) $(CAPSH_SHELL) $(CFLAGS) $(CPPFLAGS) -c $< -o $@

install: all
	mkdir -p -m 0755 $(FAKEROOT)$(SBINDIR)
	for p in $(PROGS) ; do \
		install -m 0755 $$p $(FAKEROOT)$(SBINDIR) ; \
	done
ifeq ($(RAISE_SETFCAP),yes)
	$(FAKEROOT)$(SBINDIR)/setcap cap_setfcap=i $(FAKEROOT)$(SBINDIR)/setcap
endif

test: $(PROGS)

tcapsh-static: capsh.c $(DEPS)
	$(CC) $(IPATH) $(CAPSH_SHELL) $(CFLAGS) -o $@ $< $(LIBCAPLIB) $(LDFLAGS) --static

sudotest: test
	$(DEB_GAIN_ROOT_CMD) ./quicktest.sh

clean:
	$(LOCALCLEAN)
	rm -f *.o $(BUILD) tcapsh* privileged ping hack.sh compare-cap

=== .pc/Don-t-hardcode-build-flags.patch/pam_cap/Makefile ===
# simple make file for the pam_cap module

topdir=$(shell pwd)/..
include ../Make.Rules

all: pam_cap.so
	$(MAKE) testlink

install: all
	mkdir -p -m 0755 $(FAKEROOT)$(LIBDIR)/security
	install -m 0755 pam_cap.so $(FAKEROOT)$(LIBDIR)/security

# Note (as the author of much of the Linux-PAM library, I am confident
# that this next line does *not* require -lpam on it.) If you think it
# does, *verify that it does*, and if you observe that it fails as
# written (and you know why it fails), email me and explain why. Thanks!

pam_cap.so: pam_cap.o
	$(LD) -o pam_cap.so $< $(LIBCAPLIB) $(LDFLAGS) -lpam

pam_cap.o: pam_cap.c
	$(CC) $(CFLAGS) $(IPATH) -c $< -o $@

test_pam_cap: test_pam_cap.c pam_cap.c
	$(CC) $(CFLAGS) $(IPATH) -o $@ test_pam_cap.c $(LIBCAPLIB) $(LDFLAGS) --static

testlink: test.c pam_cap.o
	$(CC) $(CFLAGS) -o $@ $+ -lpam -ldl $(LIBCAPLIB) $(LDFLAGS)

test: pam_cap.so
	make testlink

sudotest: test test_pam_cap
	sudo ./test_pam_cap root 0x0 0x0 0x0 config=./capability.conf
	sudo ./test_pam_cap root 0x0 0x0 0x0 config=./sudotest.conf
	sudo ./test_pam_cap alpha 0x0 0x0 0x0 config=./capability.conf
	sudo ./test_pam_cap alpha 0x0 0x1 0x80 config=./sudotest.conf
	sudo ./test_pam_cap beta 0x0 0x1 0x0 config=./sudotest.conf
	sudo ./test_pam_cap gamma 0x0 0x0 0x81 config=./sudotest.conf
	sudo ./test_pam_cap delta 0x41 0x80 0x41 config=./sudotest.conf

clean:
	rm -f *.o *.so testlink test_pam_cap *~

=== .pc/Filter-out-PIE-flags-when-building-shared-objects.patch/libcap/Makefile ===
#
# defines
#
topdir=$(shell pwd)/..
include ../Make.Rules
#
# Library version
#
LIBNAME=$(LIBTITLE).so
STACAPLIBNAME=$(LIBTITLE).a
#
STAPSXLIBNAME=libpsx.a

CAPFILES=cap_alloc cap_proc cap_extint cap_flag cap_text cap_file
PSXFILES=../psx/psx

INCLS=libcap.h cap_names.h $(INCS)
CAPOBJS=$(addsuffix .o, $(CAPFILES))
PSXOBJS=$(addsuffix .o, $(PSXFILES))

MAJLIBNAME=$(LIBNAME).$(VERSION)
MINLIBNAME=$(MAJLIBNAME).$(MINOR)
GPERF_OUTPUT = _caps_output.gperf

all: $(MINLIBNAME) $(STACAPLIBNAME) pcs $(STAPSXLIBNAME)

pcs: libcap.pc libpsx.pc

ifeq ($(BUILD_GPERF),yes)
USE_GPERF_OUTPUT = $(GPERF_OUTPUT)
INCLUDE_GPERF_OUTPUT = -DINCLUDE_GPERF_OUTPUT='"$(GPERF_OUTPUT)"'
endif

libcap.pc: libcap.pc.in
	sed -e 's,@prefix@,$(prefix),' \
		-e 's,@exec_prefix@,$(exec_prefix),' \
		-e 's,@libdir@,$(LIBDIR),' \
		-e 's,@includedir@,$(inc_prefix)/include,' \
		-e 's,@VERSION@,$(VERSION).$(MINOR),' \
		-e 's,@deps@,$(DEPS),' \
		$< >$@

libpsx.pc: libpsx.pc.in
	sed -e 's,@prefix@,$(prefix),' \
		-e 's,@exec_prefix@,$(exec_prefix),' \
		-e 's,@libdir@,$(LIBDIR),' \
		-e 's,@includedir@,$(inc_prefix)/include,' \
		-e 's,@VERSION@,$(VERSION).$(MINOR),' \
		-e 's,@deps@,$(DEPS),' \
		$< >$@

_makenames: _makenames.c cap_names.list.h
	$(BUILD_CC) $(BUILD_CFLAGS) $(BUILD_LDFLAGS) $(BUILD_CPPFLAGS) $< -o $@

cap_names.h: _makenames
	./_makenames > cap_names.h

$(GPERF_OUTPUT): cap_names.list.h
	perl -e 'print "struct __cap_token_s { const char *name; int index; };\n%{\n#include <stdlib.h>\nstatic const struct __cap_token_s *__cap_lookup_name(const char *, size_t);\n%}\n%%\n"; while ($$l = <>) { $$l =~ s/[\{\"]//g; $$l =~ s/\}.*// ; print $$l; }' < $< | gperf --ignore-case --language=ANSI-C --readonly --null-strings --global-table --hash-function-name=__cap_hash_name --lookup-function-name="__cap_lookup_name" -c -t -m20 $(INDENT) > $@
	sed -e 's/unsigned int len/size_t len/' -i $@

# Intention is that libcap keeps up with torvalds' tree, as reflected
# by this maintained version of the kernel header. libcap dynamically
# trims the meaning of "all" capabilities down to that of the running
# kernel as of 2.30.
UAPI_HEADER := $(topdir)/libcap/include/uapi/linux/capability.h
cap_names.list.h: Makefile $(UAPI_HEADER)
	@echo "=> making $@ from $(UAPI_HEADER)"
	perl -e 'while ($$l=<>) { if ($$l =~ /^\#define[ \t](CAP[_A-Z]+)[ \t]+([0-9]+)\s+$$/) { $$tok=$$1; $$val=$$2; $$tok =~ tr/A-Z/a-z/; print "{\"$$tok\",$$val},\n"; } }' $(UAPI_HEADER) | fgrep -v 0x > $@

$(STACAPLIBNAME): $(CAPOBJS)
	$(AR) rcs $@ $^
	$(RANLIB) $@

$(STAPSXLIBNAME): $(PSXOBJS)
	$(AR) rcs $@ $^
	$(RANLIB) $@

$(MINLIBNAME): $(CAPOBJS)
	$(LD) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -Wl,-soname,$(MAJLIBNAME) -o $@ $^
	ln -sf $(MINLIBNAME) $(MAJLIBNAME)
	ln -sf $(MAJLIBNAME) $(LIBNAME)

%.o: %.c $(INCLS)
	$(CC) $(CFLAGS) $(CPPFLAGS) $(IPATH) -c $< -o $@

cap_text.o: cap_text.c $(USE_GPERF_OUTPUT) $(INCLS)
	$(CC) $(CFLAGS) $(CPPFLAGS) $(IPATH) $(INCLUDE_GPERF_OUTPUT) -c $< -o $@

cap_test: cap_test.c libcap.h
	$(CC) $(CFLAGS) $(CPPFLAGS) $(IPATH) $< -o $@

test: cap_test
	./cap_test

install: install-static install-shared

install-static: install-static-cap install-static-psx

install-shared: install-shared-cap

install-cap: install-static-cap install-shared-cap

install-psx: install-static-psx

install-static-cap: install-common-cap $(STACAPLIBNAME)
	install -m 0644 $(STACAPLIBNAME) $(FAKEROOT)$(LIBDIR)/$(STACAPLIBNAME)

install-shared-cap: install-common-cap $(MINLIBNAME)
	install -m 0644 $(MINLIBNAME) $(FAKEROOT)$(LIBDIR)/$(MINLIBNAME)
	ln -sf $(MINLIBNAME) $(FAKEROOT)$(LIBDIR)/$(MAJLIBNAME)
	ln -sf $(MAJLIBNAME) $(FAKEROOT)$(LIBDIR)/$(LIBNAME)
ifeq ($(FAKEROOT),)
	-/sbin/ldconfig
endif

install-static-psx: install-common-psx $(STAPSXLIBNAME)
	install -m 0644 $(STAPSXLIBNAME) $(FAKEROOT)$(LIBDIR)/$(STAPSXLIBNAME)

install-common-cap: install-common libcap.pc
	install -m 0644 include/sys/capability.h $(FAKEROOT)$(INCDIR)/sys
	install -m 0644 libcap.pc $(FAKEROOT)$(PKGCONFIGDIR)/libcap.pc

install-common-psx: install-common libpsx.pc
	install -m 0644 include/sys/psx_syscall.h $(FAKEROOT)$(INCDIR)/sys
	install -m 0644 libpsx.pc $(FAKEROOT)$(PKGCONFIGDIR)/libpsx.pc

install-common:
	mkdir -p -m 0755 $(FAKEROOT)$(INCDIR)/sys
	mkdir -p -m 0755 $(FAKEROOT)$(PKGCONFIGDIR)
	mkdir -p -m 0755 $(FAKEROOT)$(LIBDIR)

clean:
	$(LOCALCLEAN)
	rm -f $(CAPOBJS) $(LIBNAME)* $(STACAPLIBNAME) libcap.pc libpsx.pc
	rm -f $(PSXOBJS) $(STAPSXLIBNAME)
	rm -f cap_names.h cap_names.list.h _makenames $(GPERF_OUTPUT) cap_test
	cd include/sys && $(LOCALCLEAN)

=== .pc/Filter-out-PIE-flags-when-building-shared-objects.patch/pam_cap/Makefile ===
# simple make file for the pam_cap module

topdir=$(shell pwd)/..
include ../Make.Rules

all: pam_cap.so
	$(MAKE) testlink

install: all
	mkdir -p -m 0755 $(FAKEROOT)$(LIBDIR)/security
	install -m 0755 pam_cap.so $(FAKEROOT)$(LIBDIR)/security

# Note (as the author of much of the Linux-PAM library, I am confident
# that this next line does *not* require -lpam on it.) If you think it
# does, *verify that it does*, and if you observe that it fails as
# written (and you know why it fails), email me and explain why. Thanks!

pam_cap.so: pam_cap.o
	$(LD) -o pam_cap.so $< $(LIBCAPLIB) $(LDFLAGS) -lpam

pam_cap.o: pam_cap.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(IPATH) -c $< -o $@

test_pam_cap: test_pam_cap.c pam_cap.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(IPATH) -o $@ test_pam_cap.c $(LIBCAPLIB) $(LDFLAGS) --static

testlink: test.c pam_cap.o
	$(CC) $(CFLAGS) -o $@ $+ -lpam -ldl $(LIBCAPLIB) $(LDFLAGS)

test: pam_cap.so
	make testlink

sudotest: test test_pam_cap
	sudo ./test_pam_cap root 0x0 0x0 0x0 config=./capability.conf
	sudo ./test_pam_cap root 0x0 0x0 0x0 config=./sudotest.conf
	sudo ./test_pam_cap alpha 0x0 0x0 0x0 config=./capability.conf
	sudo ./test_pam_cap alpha 0x0 0x1 0x80 config=./sudotest.conf
	sudo ./test_pam_cap beta 0x0 0x1 0x0 config=./sudotest.conf
	sudo ./test_pam_cap gamma 0x0 0x0 0x81 config=./sudotest.conf
	sudo ./test_pam_cap delta 0x41 0x80 0x41 config=./sudotest.conf

clean:
	rm -f *.o *.so testlink test_pam_cap *~

=== .pc/Hide-private-symbols.patch/libcap/Makefile ===
#
# defines
#
topdir=$(shell pwd)/..
include ../Make.Rules
#
# Library version
#
LIBNAME=$(LIBTITLE).so
STACAPLIBNAME=$(LIBTITLE).a
#
STAPSXLIBNAME=libpsx.a

CAPFILES=cap_alloc cap_proc cap_extint cap_flag cap_text cap_file
PSXFILES=../psx/psx

INCLS=libcap.h cap_names.h $(INCS)
CAPOBJS=$(addsuffix .o, $(CAPFILES))
PSXOBJS=$(addsuffix .o, $(PSXFILES))

MAJLIBNAME=$(LIBNAME).$(VERSION)
MINLIBNAME=$(MAJLIBNAME).$(MINOR)
GPERF_OUTPUT = _caps_output.gperf

all: $(MINLIBNAME) $(STACAPLIBNAME) pcs $(STAPSXLIBNAME)

pcs: libcap.pc libpsx.pc

ifeq ($(BUILD_GPERF),yes)
USE_GPERF_OUTPUT = $(GPERF_OUTPUT)
INCLUDE_GPERF_OUTPUT = -DINCLUDE_GPERF_OUTPUT='"$(GPERF_OUTPUT)"'
endif

libcap.pc: libcap.pc.in
	sed -e 's,@prefix@,$(prefix),' \
		-e 's,@exec_prefix@,$(exec_prefix),' \
		-e 's,@libdir@,$(LIBDIR),' \
		-e 's,@includedir@,$(inc_prefix)/include,' \
		-e 's,@VERSION@,$(VERSION).$(MINOR),' \
		-e 's,@deps@,$(DEPS),' \
		$< >$@

libpsx.pc: libpsx.pc.in
	sed -e 's,@prefix@,$(prefix),' \
		-e 's,@exec_prefix@,$(exec_prefix),' \
		-e 's,@libdir@,$(LIBDIR),' \
		-e 's,@includedir@,$(inc_prefix)/include,' \
		-e 's,@VERSION@,$(VERSION).$(MINOR),' \
		-e 's,@deps@,$(DEPS),' \
		$< >$@

_makenames: _makenames.c cap_names.list.h
	$(BUILD_CC) $(BUILD_CFLAGS) $(BUILD_LDFLAGS) $(BUILD_CPPFLAGS) $< -o $@

cap_names.h: _makenames
	./_makenames > cap_names.h

$(GPERF_OUTPUT): cap_names.list.h
	perl -e 'print "struct __cap_token_s { const char *name; int index; };\n%{\nconst struct __cap_token_s *__cap_lookup_name(const char *, size_t);\n%}\n%%\n"; while ($$l = <>) { $$l =~ s/[\{\"]//g; $$l =~ s/\}.*// ; print $$l; }' < $< | gperf --ignore-case --language=ANSI-C --readonly --null-strings --global-table --hash-function-name=__cap_hash_name --lookup-function-name="__cap_lookup_name" -c -t -m20 $(INDENT) > $@
	sed -e 's/unsigned int len/size_t len/' -i $@

# Intention is that libcap keeps up with torvalds' tree, as reflected
# by this maintained version of the kernel header. libcap dynamically
# trims the meaning of "all" capabilities down to that of the running
# kernel as of 2.30.
UAPI_HEADER := $(topdir)/libcap/include/uapi/linux/capability.h
cap_names.list.h: Makefile $(UAPI_HEADER)
	@echo "=> making $@ from $(UAPI_HEADER)"
	perl -e 'while ($$l=<>) { if ($$l =~ /^\#define[ \t](CAP[_A-Z]+)[ \t]+([0-9]+)\s+$$/) { $$tok=$$1; $$val=$$2; $$tok =~ tr/A-Z/a-z/; print "{\"$$tok\",$$val},\n"; } }' $(UAPI_HEADER) | fgrep -v 0x > $@

$(STACAPLIBNAME): $(CAPOBJS)
	$(AR) rcs $@ $^
	$(RANLIB) $@

$(STAPSXLIBNAME): $(PSXOBJS)
	$(AR) rcs $@ $^
	$(RANLIB) $@

$(MINLIBNAME): $(CAPOBJS)
	$(LD) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -Wl,-soname,$(MAJLIBNAME) -o $@ $^
	ln -sf $(MINLIBNAME) $(MAJLIBNAME)
	ln -sf $(MAJLIBNAME) $(LIBNAME)

%.o: %.c $(INCLS)
	$(CC) $(CFLAGS) $(CPPFLAGS) $(IPATH) -c $< -o $@

cap_text.o: cap_text.c $(USE_GPERF_OUTPUT) $(INCLS)
	$(CC) $(CFLAGS) $(CPPFLAGS) $(IPATH) $(INCLUDE_GPERF_OUTPUT) -c $< -o $@

cap_test: cap_test.c libcap.h
	$(CC) $(CFLAGS) $(CPPFLAGS) $(IPATH) $< -o $@

test: cap_test
	./cap_test

install: install-static install-shared

install-static: install-static-cap install-static-psx

install-shared: install-shared-cap

install-cap: install-static-cap install-shared-cap

install-psx: install-static-psx

install-static-cap: install-common-cap $(STACAPLIBNAME)
	install -m 0644 $(STACAPLIBNAME) $(FAKEROOT)$(LIBDIR)/$(STACAPLIBNAME)

install-shared-cap: install-common-cap $(MINLIBNAME)
	install -m 0644 $(MINLIBNAME) $(FAKEROOT)$(LIBDIR)/$(MINLIBNAME)
	ln -sf $(MINLIBNAME) $(FAKEROOT)$(LIBDIR)/$(MAJLIBNAME)
	ln -sf $(MAJLIBNAME) $(FAKEROOT)$(LIBDIR)/$(LIBNAME)
ifeq ($(FAKEROOT),)
	-/sbin/ldconfig
endif

install-static-psx: install-common-psx $(STAPSXLIBNAME)
	install -m 0644 $(STAPSXLIBNAME) $(FAKEROOT)$(LIBDIR)/$(STAPSXLIBNAME)

install-common-cap: install-common libcap.pc
	install -m 0644 include/sys/capability.h $(FAKEROOT)$(INCDIR)/sys
	install -m 0644 libcap.pc $(FAKEROOT)$(PKGCONFIGDIR)/libcap.pc

install-common-psx: install-common libpsx.pc
	install -m 0644 include/sys/psx_syscall.h $(FAKEROOT)$(INCDIR)/sys
	install -m 0644 libpsx.pc $(FAKEROOT)$(PKGCONFIGDIR)/libpsx.pc

install-common:
	mkdir -p -m 0755 $(FAKEROOT)$(INCDIR)/sys
	mkdir -p -m 0755 $(FAKEROOT)$(PKGCONFIGDIR)
	mkdir -p -m 0755 $(FAKEROOT)$(LIBDIR)

clean:
	$(LOCALCLEAN)
	rm -f $(CAPOBJS) $(LIBNAME)* $(STACAPLIBNAME) libcap.pc libpsx.pc
	rm -f $(PSXOBJS) $(STAPSXLIBNAME)
	rm -f cap_names.h cap_names.list.h _makenames $(GPERF_OUTPUT) cap_test
	cd include/sys && $(LOCALCLEAN)

=== .pc/Use-DEB_GAIN_ROOT_CMD-for-make-test.patch/pam_cap/Makefile ===
# simple make file for the pam_cap module

topdir=$(shell pwd)/..
include ../Make.Rules

all: pam_cap.so
	$(MAKE) testlink

install: all
	mkdir -p -m 0755 $(FAKEROOT)$(LIBDIR)/security
	install -m 0755 pam_cap.so $(FAKEROOT)$(LIBDIR)/security

CFLAGS  := $(filter-out -fPIE,$(CFLAGS))
LDFLAGS := $(filter-out -fPIE,$(filter-out -pie,$(LDFLAGS)))

# Note (as the author of much of the Linux-PAM library, I am confident
# that this next line does *not* require -lpam on it.) If you think it
# does, *verify that it does*, and if you observe that it fails as
# written (and you know why it fails), email me and explain why. Thanks!

pam_cap.so: pam_cap.o
	$(LD) -o pam_cap.so $< $(LIBCAPLIB) $(LDFLAGS) -lpam

pam_cap.o: pam_cap.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(IPATH) -c $< -o $@

test_pam_cap: test_pam_cap.c pam_cap.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(IPATH) -o $@ test_pam_cap.c $(LIBCAPLIB) $(LDFLAGS) --static

testlink: test.c pam_cap.o
	$(CC) $(CFLAGS) -o $@ $+ -lpam -ldl $(LIBCAPLIB) $(LDFLAGS)

test: pam_cap.so
	make testlink

sudotest: test test_pam_cap
	sudo ./test_pam_cap root 0x0 0x0 0x0 config=./capability.conf
	sudo ./test_pam_cap root 0x0 0x0 0x0 config=./sudotest.conf
	sudo ./test_pam_cap alpha 0x0 0x0 0x0 config=./capability.conf
	sudo ./test_pam_cap alpha 0x0 0x1 0x80 config=./sudotest.conf
	sudo ./test_pam_cap beta 0x0 0x1 0x0 config=./sudotest.conf
	sudo ./test_pam_cap gamma 0x0 0x0 0x81 config=./sudotest.conf
	sudo ./test_pam_cap delta 0x41 0x80 0x41 config=./sudotest.conf

clean:
	rm -f *.o *.so testlink test_pam_cap *~

=== .pc/Use-DEB_GAIN_ROOT_CMD-for-make-test.patch/progs/Makefile ===

topdir=$(shell pwd)/..
include $(topdir)/Make.Rules
#
# Programs: all of the examples that we will compile
#
PROGS=getpcaps capsh getcap setcap

BUILD=$(PROGS)

ifeq ($(DYNAMIC),yes)
LDPATH = LD_LIBRARY_PATH=../libcap
DEPSBUILD = all
else
LDFLAGS += --static
DEPSBUILD = libcap.a
endif

DEPS=../libcap/libcap.a

all: $(BUILD)

$(DEPS):
	make -C ../libcap $(DEPSBUILD)

$(BUILD): %: %.o $(DEPS)
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $< $(LIBCAPLIB) $(LDFLAGS)

%.o: %.c $(INCS)
	$(CC) $(IPATH) $(CAPSH_SHELL) $(CFLAGS) $(CPPFLAGS) -c $< -o $@

install: all
	mkdir -p -m 0755 $(FAKEROOT)$(SBINDIR)
	for p in $(PROGS) ; do \
		install -m 0755 $$p $(FAKEROOT)$(SBINDIR) ; \
	done
ifeq ($(RAISE_SETFCAP),yes)
	$(FAKEROOT)$(SBINDIR)/setcap cap_setfcap=i $(FAKEROOT)$(SBINDIR)/setcap
endif

test: $(PROGS)

tcapsh-static: capsh.c $(DEPS)
	$(CC) $(IPATH) $(CAPSH_SHELL) $(CFLAGS) -o $@ $< $(LIBCAPLIB) $(LDFLAGS) --static

sudotest: test tcapsh-static
	sudo $(LDPATH) ./quicktest.sh

clean:
	$(LOCALCLEAN)
	rm -f *.o $(BUILD) tcapsh* privileged ping hack.sh compare-cap

=== debian/changelog ===
libcap2 (1:2.44-1ubuntu0.22.04.2+11.0trisquel1) aramo-security; urgency=medium

  * Fetch and build as udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Mon, 24 Feb 2025 17:44:41 +0000

libcap2 (1:2.44-1ubuntu0.22.04.2) jammy-security; urgency=medium

  * SECURITY UPDATE: incorrect group name handling
    - debian/patches/CVE-2025-1390-1.patch: fix potential configuration
      parsing error in pam_cap/pam_cap.c.
    - debian/patches/CVE-2025-1390-2.patch: add a test for bad group prefix
      in pam_cap/sudotest.conf.
    - CVE-2025-1390

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 20 Feb 2025 10:51:02 -0500

libcap2 (1:2.44-1ubuntu0.22.04.1) jammy-security; urgency=medium

  * SECURITY UPDATE: process memory exhaustion in pthread_create()
    - debian/patches/CVE-2023-2602.patch: correct the check of
      pthread_create()'s return value in psx/psx.c.
    - CVE-2023-2602
  * SECURITY UPDATE: integer overflow in _libcap_strdup()
    - debian/patches/CVE-2023-2603.patch: properly handle large strings in
      libcap/cap_alloc.c.
    - CVE-2023-2603

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 07 Jun 2023 08:31:30 -0400

=== debian/control ===
Source: libcap2
Section: libs
Priority: optional
Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
XSBC-Original-Maintainer: Christian Kastner <ckk@debian.org>
Build-Depends:
    debhelper-compat (= 12),
    indent,
    libpam0g-dev,
    gperf (>= 3.1),
Rules-Requires-Root: dpkg/target-subcommand
Standards-Version: 4.5.0
Homepage: https://sites.google.com/site/fullycapable/
Vcs-Git: https://salsa.debian.org/debian/libcap2.git
Vcs-Browser: https://salsa.debian.org/debian/libcap2

Package: libcap2-bin
Section: utils
Priority: important
Architecture: linux-any
Multi-Arch: foreign
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
Breaks: libcap-bin
Replaces: libcap-bin
Recommends: libpam-cap
Description: POSIX 1003.1e capabilities (utilities)
 Libcap implements the user-space interfaces to the POSIX 1003.1e capabilities
 available in Linux kernels. These capabilities are a partitioning of the all
 powerful root privilege into a set of distinct privileges.
 .
 This package contains additional utilities.

Package: libcap2
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
Description: POSIX 1003.1e capabilities (library)
 Libcap implements the user-space interfaces to the POSIX 1003.1e capabilities
 available in Linux kernels. These capabilities are a partitioning of the all
 powerful root privilege into a set of distinct privileges.
 .
 This package contains the shared library.

Package: libcap-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    libcap2 (= ${binary:Version}),
Suggests: manpages-dev
Provides: libcap2-dev
Description: POSIX 1003.1e capabilities (development)
 Libcap implements the user-space interfaces to the POSIX 1003.1e capabilities
 available in Linux kernels. These capabilities are a partitioning of the all
 powerful root privilege into a set of distinct privileges.
 .
 This package contains the development files.

Package: libpam-cap
Section: admin
Architecture: linux-any
Multi-Arch: same
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    libpam-runtime (>= 1.1.3-2~),
Breaks: libcap2-bin (<< 1:2.22-1.1)
Replaces: libcap2-bin (<< 1:2.22-1.1)
Description: POSIX 1003.1e capabilities (PAM module)
 Libcap implements the user-space interfaces to the POSIX 1003.1e capabilities
 available in Linux kernels. These capabilities are a partitioning of the all
 powerful root privilege into a set of distinct privileges.
 .
 This package contains the PAM module for enforcing capabilities on users and
 groups at PAM session start time.

Package: libcap2-udeb
Section: debian-installer
Architecture: linux-any
Package-Type: udeb
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
Description: POSIX 1003.1e capabilities (library)
 Libcap implements the user-space interfaces to the POSIX 1003.1e capabilities
 available in Linux kernels. These capabilities are a partitioning of the all
 powerful root privilege into a set of distinct privileges.
 .
 This is a minimal version, only for use in the installation system.

## libcap2 2.66

=== doc/Makefile ===
#
# Makefile for libcap documentation
#

topdir=$(shell pwd)/..
include $(topdir)/Make.Rules

MAN1S = capsh.1
MAN3S = cap_init.3 cap_free.3 cap_dup.3 \
	cap_clear.3 cap_clear_flag.3 cap_get_flag.3 cap_set_flag.3 \
	cap_fill.3 cap_fill_flag.3 cap_max_bits.3 \
	cap_compare.3 cap_get_proc.3 cap_get_pid.3 cap_set_proc.3 \
	cap_get_file.3 cap_get_fd.3 cap_set_file.3 cap_set_fd.3 \
	cap_copy_ext.3 cap_size.3 cap_copy_int.3 cap_mode.3 \
	cap_from_text.3 cap_to_text.3 cap_from_name.3 cap_to_name.3 \
	capsetp.3 capgetp.3 libcap.3 \
	cap_get_bound.3 cap_drop_bound.3 \
	cap_get_mode.3 cap_set_mode.3 cap_mode_name.3 \
	cap_get_secbits.3 cap_set_secbits.3 \
	cap_setuid.3 cap_setgroups.3 \
	cap_launch.3 cap_func_launcher.3 cap_launcher_callback.3 \
	cap_launcher_set_chroot.3 cap_launcher_set_mode.3 \
	cap_launcher_setgroups.3 cap_launcher_setuid.3 \
	cap_launcher_set_iab.3 cap_new_launcher.3 \
	cap_iab.3 cap_iab_init.3 cap_iab_dup.3 cap_iab_compare.3 \
	cap_iab_get_proc.3 cap_iab_get_pid.3 cap_iab_set_proc.3 \
	cap_iab_to_text.3 cap_iab_from_text.3 cap_iab_get_vector.3 \
	cap_iab_set_vector.3 cap_iab_fill.3 \
	psx_syscall.3 psx_syscall3.3 psx_syscall6.3 psx_set_sensitivity.3 \
	libpsx.3
MAN8S = getcap.8 setcap.8 getpcaps.8 captree.8

MANS = $(MAN1S) $(MAN3S) $(MAN8S)

all: $(MANS)

test:
	@echo no doc tests available

sudotest:
	@echo no doc sudotests available

.PHONY: html
html:
	mkdir -p html
	for man in $(MANS) ; \
	do \
		$(BUILD_EGREP) '^\.so man' $$man > /dev/null || \
		groff -man -Thtml $$man > html/$$man.html ; \
	done

install:
	mkdir -p -m 755 $(FAKEROOT)$(MANDIR)/man1 $(FAKEROOT)$(MANDIR)/man3 $(FAKEROOT)$(MANDIR)/man8
	for man in \
		$(FAKEROOT)$(MANDIR)/man1 $(MAN1S) \
		$(FAKEROOT)$(MANDIR)/man3 $(MAN3S) \
		$(FAKEROOT)$(MANDIR)/man8 $(MAN8S) \
		; \
	do \
		case $$man in \
		/*)	sub=$$man ; continue ;; \
		esac; \
		install -m 644 $$man $$sub ; \
	done

clean:
	$(LOCALCLEAN)
	rm -rf html

=== pam_cap/Makefile ===
# simple make file for the pam_cap module

topdir=$(shell pwd)/..
include ../Make.Rules

# Always build pam_cap sources this way:
CFLAGS += -fPIC

all: pam_cap.so
	$(MAKE) testlink

install: all
	mkdir -p -m 0755 $(FAKEROOT)$(LIBDIR)/security
	install -m 0755 pam_cap.so $(FAKEROOT)$(LIBDIR)/security

../libcap/loader.txt:
	$(MAKE) -C ../libcap loader.txt

execable.o: execable.c ../libcap/execable.h ../libcap/loader.txt
	$(CC) $(CFLAGS) $(CPPFLAGS) -DLIBCAP_VERSION=\"libcap-$(VERSION).$(MINOR)\" -DSHARED_LOADER=\"$(shell cat ../libcap/loader.txt)\" -c execable.c -o $@

LIBCAP:
	$(MAKE) -C ../libcap all
	touch $@

pam_cap.so: pam_cap.o execable.o pam_cap_linkopts LIBCAP
	cat pam_cap_linkopts | xargs -e $(LD) $(LDFLAGS) -o $@ pam_cap.o execable.o $(LIBCAPLIB)

# Some distributions force link everything at compile time, and don't
# take advantage of libpam's dlopen runtime options to resolve ill
# defined symbols from its own linkage as needed. (As the original
# author of that part of libpam, I consider this force linking
# premature optimization.) We debugged its consequences to pam_cap.so
# as part of:
#
#   https://bugzilla.kernel.org/show_bug.cgi?id=214023
#
# If the current build environment is one of those, or we can't
# reliably prove it isn't, extend the link options for pam_cap.so to
# force linkage against libpam and the gazillion other things libpam
# is linked against...
#
# If you want to force this behavior one way or the other, use the
# make FORCELINKPAM=yes or FORCELINKPAM=no override.
ifeq ($(FORCELINKPAM),yes)
pam_cap_linkopts: Makefile
	echo "-Wl,-e,__so_start -lpam" > $@
else
ifeq ($(FORCELINKPAM),no)
pam_cap_linkopts: Makefile
	echo "-Wl,-e,__so_start" > $@
else
pam_cap_linkopts: lazylink.so
	echo "-Wl,-e,__so_start" > $@
	./lazylink.so || echo "-lpam" >> $@

lazylink.so: lazylink.c ../libcap/execable.h ../libcap/loader.txt
	$(LD) -o $@ $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) lazylink.c -DSHARED_LOADER=\"$(shell cat ../libcap/loader.txt)\" -Wl,-e,__so_start
endif
endif

../libcap/libcap.a:
	$(MAKE) -C ../libcap libcap.a

# Avoid $(LDFLAGS) here to avoid conflicts with --static for a in-tree
# test binary.
test_pam_cap: test_pam_cap.c pam_cap.c ../libcap/libcap.a
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ test_pam_cap.c $(LIBCAPLIB) --static

testlink: test.o pam_cap.o
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $+ -lpam -ldl $(LIBCAPLIB)

test: testlink test_pam_cap pam_cap.so
	./test_pam_cap
	LD_LIBRARY_PATH=../libcap ./pam_cap.so
	LD_LIBRARY_PATH=../libcap ./pam_cap.so --help
	@echo "module can be run as an executable!"

sudotest: test_pam_cap
	$(SUDO) ./test_pam_cap root 0x0 0x0 0x0 config=./capability.conf
	$(SUDO) ./test_pam_cap root 0x0 0x0 0x0 config=./sudotest.conf
	$(SUDO) ./test_pam_cap alpha 0x0 0x0 0x0 config=./capability.conf
	$(SUDO) ./test_pam_cap alpha 0x0 0x1 0x80 config=./sudotest.conf
	$(SUDO) ./test_pam_cap beta 0x0 0x1 0x0 config=./sudotest.conf
	$(SUDO) ./test_pam_cap gamma 0x0 0x0 0x81 config=./sudotest.conf
	$(SUDO) ./test_pam_cap delta 0x41 0x80 0x41 config=./sudotest.conf

clean:
	rm -f *.o *.so testlink lazylink.so test_pam_cap pam_cap_linkopts *~
	rm -f LIBCAP

=== debian/changelog ===
libcap2 (1:2.66-5ubuntu2) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 18:01:58 +0200

libcap2 (1:2.66-5ubuntu1) noble; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Strip -Wl,-Bsymbolic-functions from LDFLAGS (LP #2003892)
    - d/t/upstream-root: Skip "uns_test" to fix autopkgtests on armhf.
      It's failing on armhf due to the version of the kernel we use in our
      infrastructure for for this architecture. Once we upgrade our hosts,
      this patch can be dropped. See LP #2003892.

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 22 Feb 2024 13:06:11 +0100

libcap2 (1:2.66-5) unstable; urgency=medium

  [ Helmut Grohne ]
  *  Move files to /usr for DEP17. (Closes: #1060140)

  [ Christian Kastner ]
  * Add Skip-git-if-not-installed.patch (Closes: #1046986)

 -- Christian Kastner <ckk@debian.org>  Tue, 06 Feb 2024 20:16:09 +0100

libcap2 (1:2.66-4ubuntu1) mantic; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Strip -Wl,-Bsymbolic-functions from LDFLAGS (LP: #2003892)
    - d/t/upstream-root: Skip "uns_test" to fix autopkgtests on armhf.
      It's failing on armhf due to the version of the kernel we use in our
      infrastructure for for this architecture. Once we upgrade our hosts,
      this patch can be dropped. See LP: #2003892.

 -- Danilo Egea Gondolfo <danilo.egea.gondolfo@canonical.com>  Tue, 23 May 2023 11:11:27 +0100

libcap2 (1:2.66-4) unstable; urgency=medium

  * Apply upstream patches for CVE-2023-2602, CVE-2023-2603
    (Closes: #1036114)

 -- Christian Kastner <ckk@debian.org>  Mon, 15 May 2023 20:34:57 +0200

libcap2 (1:2.66-3ubuntu2) lunar; urgency=medium

  * Skip the test uns_test to fix autopkgtest on armhf.
    It's failing on armhf because we are using an older kernel in the armhf
    builders. This test succeeds on newer versions. Once we upgrade our
    hosts this patch can be dropped. See LP#2003892

 -- Danilo Egea Gondolfo <danilo.egea.gondolfo@canonical.com>  Fri, 03 Feb 2023 11:18:40 +0000

libcap2 (1:2.66-3ubuntu1) lunar; urgency=medium

  * Strip -Wl,-Bsymbolic-functions from LDFLAGS (LP: #2003892)

 -- Danilo Egea Gondolfo <danilo.egea.gondolfo@canonical.com>  Wed, 25 Jan 2023 18:07:03 +0000

libcap2 (1:2.66-3) unstable; urgency=medium

  * Add gcc to autopkgtest for upstream tests.
    Otherwise dpkg-architecture prints a warning to stderr, triggering a
    an autopkgtest FAIL. (Closes: #1026773)

 -- Christian Kastner <ckk@debian.org>  Wed, 21 Dec 2022 21:19:49 +0100

libcap2 (1:2.66-2) unstable; urgency=medium

  [ Christian Kastner ]
  * Add missing Breaks/Replaces for libpam-cap man page takeover
    (Closes: #1026001)

  [ Helmut Grohne ]
  * Fix FTCBFS (Closes: #1025983)
    - Let dh_auto_build pass cross tools to test program builds.
    - Pass FORCELINKPAM to all targets.
    - Pass CROSS_COMPILE to cover objcopy.
    - Skip passing CC as dh_auto_build already passes it.

 -- Christian Kastner <ckk@debian.org>  Wed, 14 Dec 2022 00:27:37 +0100

libcap2 (1:2.66-1) unstable; urgency=medium

  * New upstream release.

  [ Helmut Grohne ]
  * Support the noudeb build profile (Closes: #1024918)

  [ Christian Kastner ]
  * Install tests in arch-specific directory (Closes: #1025957)
  * Rework autopkgtests
  * Add chrpath to Build-Depends, for removing RPATH from test binaries
  * Fix existing lintian override pattern
  * Add lintian overrides for static test binaries
  * Add missing Build-Depends-Package to symbols file
  * Move pam_cap manpages from libcap2-bin to libpam-cap
  * Add lintian override for pam_cap man page
  * Bump d/copyright

 -- Christian Kastner <ckk@debian.org>  Sun, 11 Dec 2022 15:49:58 +0100

libcap2 (1:2.63-1) unstable; urgency=medium

  * Upload to unstable.

 -- Christian Kastner <ckk@debian.org>  Sat, 10 Dec 2022 14:06:25 +0100

libcap2 (1:2.63-1~exp1) experimental; urgency=medium

  * New upstream release. (Closes: #1000217)
    - Drop ldlibs.patch
    - Drop setcap-error-message.patch.
    - Drop Don-t-hardcode-build-flags.patch.
    - Drop Use-DEB_GAIN_ROOT_CMD-for-make-test.patch
    - Drop Make.Rules-Allow-overriding-DYNAMIC.patch
    - Add Fix-path-for-saved-test-binaries.patch
    - Refresh other patches
  * Bump symbols file
  * Bump Standards-Version to 4.6.1 (no changes needed)
  * Bump debhelper compatibility to 13
  * Install accompanying helper library libpsx. This library might be shipped
    separately at a later point in time
  * Save away test binaries for autopkgtest
  * Extend autopkgtests to run the saved test binaries
  * Switch Rules-Requires-Root to 'no'. (Closes: #1011772)

 -- Christian Kastner <ckk@debian.org>  Mon, 13 Jun 2022 22:49:34 +0200

libcap2 (1:2.45-1) unstable; urgency=medium

  * New upstream release.
    - Refresh patches
  * Bump Standards-Version to 4.5.1 (no changes needed)
  * libcap2.symbols: Drop accidental Debian revision from one symbol

 -- Christian Kastner <ckk@debian.org>  Mon, 07 Dec 2020 17:36:08 +0100

=== debian/rules ===
#!/usr/bin/make -f

# Exports DEB_{BUILD,HOST}_* flags
include /usr/share/dpkg/architecture.mk

# Pass this as version-info to dh_makeshlibs
SHLIBS_MINVER = 1:2.63

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Removing the linker flag. It causes problems with libcap2, see LP#2003892
export DEB_LDFLAGS_MAINT_STRIP = -Wl,-Bsymbolic-functions

# Support cross-compiling
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
CC := $(DEB_HOST_GNU_TYPE)-gcc
endif

# One upstream target, "_makenames", requires the BUILD compiler instead of HOST
BUILD_CC ?= cc
export BUILD_LDFLAGS = $(shell dpkg-architecture -a$(DEB_BUILD_ARCH) -c dpkg-buildflags --get LDFLAGS)
export BUILD_CPPFLAGS = $(shell dpkg-architecture -a$(DEB_BUILD_ARCH) -c dpkg-buildflags --get CPPFLAGS)

# Upstream's way of setting optimization
ifneq (,$(filter noopt, $(DEB_BUILD_OPTIONS)))
COPTS = COPTS=-O0
endif

# See pam_cap/Makefile for FORCELINKPAM
MAKE_ASSIGNMENTS = \
	prefix=/usr \
	FORCELINKPAM=yes \
	GOLANG=no

%:
	dh ${@}


override_dh_auto_clean:
	dh_auto_clean -- $(MAKE_ASSIGNMENTS)


override_dh_auto_build:
	# See pam_cap/Makefile for FORCELINKPAM
	dh_auto_build -- \
		$(MAKE_ASSIGNMENTS) \
		BUILD_CC=$(BUILD_CC) \
		CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)- \
		$(COPTS) \
		DYNAMIC=yes \
		SUDO=$(DEB_GAIN_ROOT_CMD)
	# Some of test suite is only invoked when run as real root. Explicitly
	# build all binaries so we can include them in the autopkgtest.	
	dh_auto_build -D libcap -- $(MAKE_ASSIGNMENTS) cap_test
	dh_auto_build -D pam_cap -- $(MAKE_ASSIGNMENTS) test_pam_cap
	# Change lookup from sibling dir to current dir
	sed -i -e 's,\.\./progs/tcapsh-static,./tcapsh-static,g' tests/libcap_launch_test.c
	dh_auto_build -D tests -- $(MAKE_ASSIGNMENTS) \
		psx_test \
		libcap_psx_test \
		uns_test \
		libcap_launch_test \
		libcap_psx_launch_test \
		noop \
		exploit \
		noexploit
	dh_auto_build -D progs -- $(MAKE_ASSIGNMENTS) tcapsh-static


override_dh_installdirs:
	dh_installdirs
	# While the PAM module and the library are in /lib, according to the
	# FHS, development files must go into usr/lib/<triplet>.
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)


override_dh_auto_install:
	# Unfortunately, RPATH seems to be needed for the build-time tests
	# (avoiding it and going through LD_LIBRARY_PATH didn't work in all
	# cases)
	# List is identical to build above, minus noop (no RPATH)
	cd tests && chrpath -d \
		psx_test \
		libcap_psx_test \
		uns_test \
		libcap_launch_test \
		libcap_psx_launch_test \
		exploit \
		noexploit
	dh_auto_install -- \
		$(MAKE_ASSIGNMENTS) \
		lib=lib/$(DEB_HOST_MULTIARCH) \
		PKGCONFIGDIR=/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
		RAISE_SETFCAP=no


override_dh_auto_test:
	dh_auto_test -- $(MAKE_ASSIGNMENTS)


override_dh_makeshlibs:
	dh_makeshlibs -V'libcap2 (>= $(SHLIBS_MINVER))' -plibcap2 \
		--add-udeb=libcap2-udeb -- -c4
	dh_makeshlibs --remaining-packages -- -c4

=== debian/tests/control ===
Tests: executables
Restrictions: needs-root
Depends: gcc, libc-dev, libcap2-bin

Tests: upstream-root
Restrictions: needs-root, allow-stderr
Depends: gcc, libcap-dev

Tests: upstream-nonroot
Depends: gcc, libcap-dev

## libcap2 2.66-5ubuntu2.1trisquel1

=== debian/changelog ===
libcap2 (1:2.66-5ubuntu2.1trisquel1) ecne; urgency=medium

  * Fetch and build as udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Mon, 27 Jan 2025 18:45:07 +0000

libcap2 (1:2.66-5ubuntu2.1) noble; urgency=medium

  * SRU: LP: #2083480: No-change rebuild to disable frame pointers on
    ppc64el and s390x.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 02 Oct 2024 14:40:50 +0200

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,13 @@
 Priority: optional
 Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 XSBC-Original-Maintainer: Christian Kastner <ckk@debian.org>
-Build-Depends:
-    debhelper-compat (= 12),
-    indent,
-    libpam0g-dev,
-    gperf (>= 3.1),
-Rules-Requires-Root: dpkg/target-subcommand
-Standards-Version: 4.5.0
+Build-Depends: chrpath,
+               debhelper-compat (= 13),
+               gperf (>= 3.1),
+               indent,
+               libpam0g-dev,
+Rules-Requires-Root: no
+Standards-Version: 4.6.1
 Homepage: https://sites.google.com/site/fullycapable/
 Vcs-Git: https://salsa.debian.org/debian/libcap2.git
 Vcs-Browser: https://salsa.debian.org/debian/libcap2
@@ -19,9 +19,7 @@
 Priority: important
 Architecture: linux-any
 Multi-Arch: foreign
-Depends:
-    ${shlibs:Depends},
-    ${misc:Depends},
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Breaks: libcap-bin
 Replaces: libcap-bin
 Recommends: libpam-cap
@@ -36,9 +34,7 @@
 Architecture: linux-any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Depends:
-    ${misc:Depends},
-    ${shlibs:Depends},
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: POSIX 1003.1e capabilities (library)
  Libcap implements the user-space interfaces to the POSIX 1003.1e capabilities
  available in Linux kernels. These capabilities are a partitioning of the all
@@ -50,10 +46,7 @@
 Section: libdevel
 Architecture: linux-any
 Multi-Arch: same
-Depends:
-    ${misc:Depends},
-    ${shlibs:Depends},
-    libcap2 (= ${binary:Version}),
+Depends: libcap2 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Suggests: manpages-dev
 Provides: libcap2-dev
 Description: POSIX 1003.1e capabilities (development)
@@ -67,12 +60,9 @@
 Section: admin
 Architecture: linux-any
 Multi-Arch: same
-Depends:
-    ${misc:Depends},
-    ${shlibs:Depends},
-    libpam-runtime (>= 1.1.3-2~),
-Breaks: libcap2-bin (<< 1:2.22-1.1)
-Replaces: libcap2-bin (<< 1:2.22-1.1)
+Depends: libpam-runtime (>= 1.1.3-2~), ${misc:Depends}, ${shlibs:Depends}
+Breaks: libcap2-bin (<< 1:2.66-1)
+Replaces: libcap2-bin (<< 1:2.66-1)
 Description: POSIX 1003.1e capabilities (PAM module)
  Libcap implements the user-space interfaces to the POSIX 1003.1e capabilities
  available in Linux kernels. These capabilities are a partitioning of the all
@@ -85,9 +75,8 @@
 Section: debian-installer
 Architecture: linux-any
 Package-Type: udeb
-Depends:
-    ${shlibs:Depends},
-    ${misc:Depends},
+Build-Profiles: <!noudeb>
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: POSIX 1003.1e capabilities (library)
  Libcap implements the user-space interfaces to the POSIX 1003.1e capabilities
  available in Linux kernels. These capabilities are a partitioning of the all
